/*
Lesson 1. *The Basics of the Basics*

Many people want to program, or create games.
Why don't they? For a variety of reasons- I can't tell
you why- but I will say that for those who actually want to
they can accomplish this task.

It seems daunting at first but with practice you can easily
learn to program.

There is however an order to learning. First you need to learn
the basics, then you need to learn how to 'use' the basics.
(You'll learn the difference soon.) That brings me to this point
if you are a beginner, you aren't doing yourself any favors by
skipping text, not reading or skipping around this lesson. You
first need to know what to do with the knowledge you are about
to gain, and for that you need a basic understanding of some
general ideas. If you skip around, avoid or try to "cheat" your
way into learning to code, all you will earn is bad practice.
*You've been warned!*


Programming is roughly divided up into three areas:

Language-the programming language needed to program.
Experience-Using the language to code.
Knowledge- The base of information you have to draw from.


This first lesson will focus on the Knowledge aspect.
While all are equally important, knowing how is the key to
actually being able to program.

For you to understand that, you have to wrap your brain around
some theory, then learn how to "think" like a programmer would
to apply that theory.


-The Apple Talk-

Imagine an apple. Say aloud 4 characteristics of an apple. Juicy?
Sweet? Sour? Red Skin? Green Skin? You might ask what this has
to do with programming. I'll tell you, a lot!

Using Dream Maker programming language is very easy to get into
but first you have to realize the "apple".

From a programmer's standpoint I see 4 variables and an object.
Within DM, it is an object-oriented programming language.(OO)
What this means is that the language is based upon real
world instances. If I were to create an apple in code form for a
project, the apple could have a taste, a scent, it could have a
value, literally anything you'd like to apply to it.

The same holds true for literally anything you code. I code
code a bat in my game, and if I wanted to it could be made of metal
, wood, or even feathers (bit silly, but true).

-Atoms-'wut'?

Within DM there is a preset instance used as a basis for all code.
It's called an atom.
An atom is the root of all instances within DM, in other words
everything comes from the root.

There are two main types of atoms. Movable ones and non-movables
or simply (atom). Movable atoms do exactly as the name suggests-
the atoms have the ability to move on their own.

In real world comparison a movable atom would be something
like an animal or a person.

A non movable would be something like a pencil, or rock.


The basic atoms for use in DM are mob,obj,turf,area and datum.

They each serve a specific role-
Mob- is a mobile object - aka something you'd use for a person
or other creature that is living.
Obj- is an object - this could be anything that doesn't move
on it's own.
Turf- This is the "ground" so to speak.
Area- This is the area in which everything else resides.

-Action Atoms

All atoms have predetermined abilities associated with them.
For instance mobs can Move, turfs can be Entered, objs can
have instances stored within. Each atom type has variables,
procedures and verbs associated with them.
( More on this in future chapter.)

It's important to be knowledgable about everything I've just
mentioned for one simple fact alone- it will make your life
easier. If you ask any seasoned programmer what is the most
difficult and time consuming part of programming, they will tell
you that it's finding out that one thing you 'didn't' know.

By familiarizing yourself with the basics of what you will
be working with, you'll find it easier to do things you never
thought possible and cut down the amount of time it takes to learn.
In Lesson 2 we will explore more in depth with the basics of
atoms as building blocks and their uses.

-Syntax-what's that?

Imagine trying to speak to a person that doesn't understand your
language. Now imagine trying to speak to someone who knows your
language but butchers it- that is syntax. It's basically the ability
of your program to understand what it is you are typing. If you don't
understand the correct way to speak to your program (which is the
language), errors will occur. Fortunately in DM there are several
ways to accomplish what you want.


Read on in lesson 2 to learn more.

*/